"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var normalizeInstrumentations_1 = require("./normalizeInstrumentations");
var request;
var hasSupport = function () { return !!window.PaymentRequest; };
var addEventListener = function (requestListener, event, callback) {
    if (!!callback) {
        requestListener.addEventListener(event, function (e) { return e.updateWith(new Promise(function (resolve, reject) { return callback(requestListener, resolve, reject); })); });
    }
};
exports.abort = function () { return request.abort(); };
exports.show = function (params) { return function () {
    request = new PaymentRequest(normalizeInstrumentations_1.default(params.methodData), params.details, params.options || {});
    addEventListener(request, 'shippingaddresschange', params.onShippingAddressChange);
    addEventListener(request, 'shippingoptionchange', params.onShippingOptionChange);
    request.show()
        .then(function (paymentResponse) {
        return new Promise(function (resolve, reject) {
            return params.onShowSuccess(paymentResponse, resolve, reject);
        })
            .then(function () { return paymentResponse.complete('success'); })
            .catch(function () { return paymentResponse.complete('fail'); });
    })
        .catch(function (err) { return params.onShowFail(err); });
}; };
var paymentRequest = function () { return function (WrappedComponent) { return ((function (_super) {
    __extends(ExtendedComponent, _super);
    function ExtendedComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ExtendedComponent.prototype.render = function () {
        var _a = this.props, config = _a.config, passedProps = __rest(_a, ["config"]);
        var isSupported = hasSupport();
        var supportedProps = isSupported && config
            ? { isSupported: isSupported, abort: exports.abort, show: exports.show(config) }
            : { isSupported: isSupported };
        return React.createElement(WrappedComponent, __assign({}, passedProps, supportedProps));
    };
    return ExtendedComponent;
}(React.Component))); }; };
exports.default = paymentRequest;
//# sourceMappingURL=paymentRequest.js.map